"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extractCssChunksWebpackPlugin = _interopRequireDefault(require("extract-css-chunks-webpack-plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var _default = function _default(_ref) {
  var _ref$includePaths = _ref.includePaths,
      includePaths = _ref$includePaths === void 0 ? [] : _ref$includePaths,
      rest = _objectWithoutProperties(_ref, ["includePaths"]);

  return {
    webpack: function webpack(config, _ref2) {
      var stage = _ref2.stage;
      var loaders = [];

      var sassLoaderPath = require.resolve('sass-loader');

      var sassLoader = {
        loader: sassLoaderPath,
        options: _objectSpread({
          includePaths: ['src/'].concat(_toConsumableArray(includePaths))
        }, rest)
      };
      var styleLoader = {
        loader: 'style-loader'
      };
      var cssLoader = {
        loader: 'css-loader',
        options: {
          importLoaders: 1,
          minimize: stage === 'prod',
          sourceMap: false
        }
      };

      if (stage === 'dev') {
        // Dev
        loaders = [styleLoader, cssLoader, sassLoader];
      } else if (stage === 'node') {
        // Node
        // Don't extract css to file during node build process
        loaders = [cssLoader, sassLoader];
      } else {
        // Prod
        loaders = [_extractCssChunksWebpackPlugin.default.loader, cssLoader, sassLoader];
      }

      config.module.rules[0].oneOf.unshift({
        test: /\.s(a|c)ss$/,
        use: loaders
      });
      return config;
    }
  };
};

exports.default = _default;